'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcCheckbox = require('rc-checkbox');

var _rcCheckbox2 = _interopRequireDefault(_rcCheckbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props) {
    _classCallCheck(this, Checkbox);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.handleClick = function () {
      _this.setState({ checked: !_this.state.checked }, function () {
        if (_this.props.onChange) {
          _this.props.onChange(_this.props.checked);
        }
      });
    };

    _this.handleChange = function (e, checked) {
      if (_this.props.onChange) {
        _this.props.onChange(checked);
      }
    };

    _this.state = {
      checked: props.defaultChecked || false
    };
    return _this;
  }

  Checkbox.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextPrps) {
    if (nextPrps.checked !== this.props.checked) {
      this.setState({ checked: nextPrps.checked });
    }
  };

  Checkbox.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        prefixCls = _props.prefixCls,
        restPrps = _objectWithoutProperties(_props, ['children', 'prefixCls']);

    return _react2.default.createElement(
      'lable',
      { className: prefixCls + '-wrapper',
        onClick: this.handleClick
      },
      _react2.default.createElement(_rcCheckbox2.default, _extends({
        checked: this.state.checked,
        prefixCls: prefixCls,
        onChange: this.handleChange
      }, restPrps)),
      children !== undefined ? _react2.default.createElement(
        'span',
        null,
        children
      ) : null
    );
  };

  return Checkbox;
}(_react.Component);

Checkbox.defaultProps = {
  prefixCls: 'dh-checkbox2'
};
exports.default = Checkbox;